package eu.mhsl.craftattack.worldmuseum;

import eu.mhsl.craftattack.worldmuseum.listener.ClickListener;
import eu.mhsl.craftattack.worldmuseum.worlds.WorldManager;
import net.minestom.server.MinecraftServer;
import net.minestom.server.coordinate.Pos;
import net.minestom.server.entity.GameMode;
import net.minestom.server.entity.Player;
import net.minestom.server.event.GlobalEventHandler;
import net.minestom.server.event.player.PlayerLoginEvent;
import net.minestom.server.event.player.PlayerUseItemEvent;
import net.minestom.server.instance.InstanceContainer;
import net.minestom.server.instance.InstanceManager;
import net.minestom.server.instance.block.Block;


import java.util.ArrayList;
import java.util.List;

public class Main {
    static int PORT = 25565;
    static String IP = "0.0.0.0";
    static List<InstanceContainer> worlds = new ArrayList<>();

    public static void main(String[] args) {
        // Initialization
        System.setProperty("minestom.chunk-view-distance", "16");
        MinecraftServer minecraftServer = MinecraftServer.init();
        InstanceManager instanceManager = MinecraftServer.getInstanceManager();

        //load eu.mhsl.craftattack.worldmuseum.worlds / configExample file
        WorldManager.getInstance().loadWorlds();



        // Create starting-instance / world
        InstanceContainer instanceContainer = instanceManager.createInstanceContainer();
        instanceContainer.setBlock(0,0,0,Block.STONE);


        // Add an event callback to specify the spawning instance (and the spawn position)
        GlobalEventHandler globalEventHandler = MinecraftServer.getGlobalEventHandler();
        globalEventHandler.addListener(PlayerLoginEvent.class, event -> {
            final Player player = event.getPlayer();
            event.setSpawningInstance(instanceContainer);
            player.setRespawnPoint(new Pos(0.5,2,0.5));
            player.setGameMode(GameMode.CREATIVE);




            for (int i = 0; i< WorldManager.getInstance().getWorlds().size(); i++) {
                if (WorldManager.getInstance().getWorlds().get(i).isEnabled()) {
                    player.getInventory().setItemStack(i, WorldManager.getInstance().getWorlds().get(i).getItem());
                } else {
                    System.out.println("Es gibt nicht aktivierte Welten!");
                }
            }
        });
        globalEventHandler.addListener(PlayerUseItemEvent.class, new ClickListener());
        try {
            PORT = Integer.parseInt(args[0]);
        } catch (Exception e) {
            if (args.length != 0) System.out.println("Given port doesn't work.");
        }
        // Start the server on port default port 25565 if none is given
        System.out.println("Running on " + IP + ":" + PORT);
        minecraftServer.start(IP, PORT);
    }
}